import{s as Ge,n as Ke,o as Qe}from"../chunks/scheduler.db6b1edd.js";import{S as Ve,i as Xe,g as a,s as o,p as pe,A as Ze,h as n,f as t,c as l,j as c,q as de,m as u,k as i,v as h,a as s,r as fe,d as ve,t as me,u as we}from"../chunks/index.5491deae.js";import{I as be}from"../chunks/IconCopyLink.2cb9a330.js";function et(ye){let p,R,d,w,U,_,xe,I,ke="Server infrastructure",Y,C,$e='The <a href="https://github.com/huggingface/datasets-server" rel="nofollow">Datasets Server</a> has two main components that work together to return queries about a dataset instantly:',B,y,Pe="<li>a user-facing web API for exploring and returning information about a dataset</li> <li>a server runs the queries ahead of time and caches them in a database</li>",G,k,qe="While most of the documentation is focused on the web API, the server is crucial because it performs all the time-consuming preprocessing and stores the results so the web API can retrieve and serve them to the user. This saves a user time because instead of generating the response every time it gets requested, Datasets Server can return the preprocessed results instantly from the cache.",K,$,Te="There are three elements that keep the server running: the job queue, workers, and the cache.",Q,f,b,z,P,ge,W,je="Job queue",V,q,Ae="The job queue is a list of jobs stored in a Mongo database that should be completed by the workers. The jobs are practically identical to the endpoints the user uses; only the server runs the jobs ahead of time, and the user gets the results when they use the endpoint.",X,T,He="There are three jobs:",Z,j,Se='<li><code>/splits</code> corresponds to the <code>/splits</code> endpoint. It refreshes a dataset and then returns that dataset’s splits and configurations. For every split in the dataset, it’ll create a new job.</li> <li><code>/first-rows</code> corresponds to the <code>/first-rows</code> endpoint. It gets the first 100 rows and columns of a dataset split.</li> <li><code>/parquet</code> corresponds to the <code>/parquet</code> endpoint. It downloads the whole dataset, converts it to <a href="https://parquet.apache.org/" rel="nofollow">parquet</a> and publishes the parquet files to the Hub.</li>',ee,A,Le="You might’ve noticed the <code>/rows</code> and <code>/search</code> endpoints don’t have a job in the queue. The responses from these endpoints are generated on demand.",te,v,x,O,H,_e,D,Me="Workers",re,S,Ee="Workers are responsible for executing the jobs in the queue. They complete the actual preprocessing requests, such as getting a list of splits and configurations. The workers can be controlled by configurable environment variables, like the minimum or the maximum number of rows returned by a worker or the maximum number of jobs to start per dataset user or organization.",se,L,Ne='Take a look at the <a href="https://github.com/huggingface/datasets-server/tree/main/services/worker#configuration" rel="nofollow">workers configuration</a> for a complete list of the environment variables if you’re interested in learning more.',ae,m,g,F,M,Ce,J,Ie="Cache",ne,E,We="Once the workers complete a job, the results are stored - or <em>cached</em> - in a Mongo database. When a user makes a request with an endpoint like <code>/first-rows</code>, Datasets Server retrieves the preprocessed response from the cache, and serves it to the user. This eliminates the time a user would’ve waited if the server hadn’t already completed the job and stored the response.",oe,N,De="As a result, users can get their requested information about a dataset (even large ones) nearly instantaneously!",le;return _=new be({}),P=new be({}),H=new be({}),M=new be({}),{c(){p=a("meta"),R=o(),d=a("h1"),w=a("a"),U=a("span"),pe(_.$$.fragment),xe=o(),I=a("span"),I.textContent=ke,Y=o(),C=a("p"),C.innerHTML=$e,B=o(),y=a("ul"),y.innerHTML=Pe,G=o(),k=a("p"),k.textContent=qe,K=o(),$=a("p"),$.textContent=Te,Q=o(),f=a("h2"),b=a("a"),z=a("span"),pe(P.$$.fragment),ge=o(),W=a("span"),W.textContent=je,V=o(),q=a("p"),q.textContent=Ae,X=o(),T=a("p"),T.textContent=He,Z=o(),j=a("ul"),j.innerHTML=Se,ee=o(),A=a("p"),A.innerHTML=Le,te=o(),v=a("h2"),x=a("a"),O=a("span"),pe(H.$$.fragment),_e=o(),D=a("span"),D.textContent=Me,re=o(),S=a("p"),S.textContent=Ee,se=o(),L=a("p"),L.innerHTML=Ne,ae=o(),m=a("h2"),g=a("a"),F=a("span"),pe(M.$$.fragment),Ce=o(),J=a("span"),J.textContent=Ie,ne=o(),E=a("p"),E.innerHTML=We,oe=o(),N=a("p"),N.textContent=De,this.h()},l(e){const r=Ze("svelte-1phssyn",document.head);p=n(r,"META",{name:!0,content:!0}),r.forEach(t),R=l(e),d=n(e,"H1",{class:!0});var ie=c(d);w=n(ie,"A",{id:!0,class:!0,href:!0});var Je=c(w);U=n(Je,"SPAN",{});var Ue=c(U);de(_.$$.fragment,Ue),Ue.forEach(t),Je.forEach(t),xe=l(ie),I=n(ie,"SPAN",{"data-svelte-h":!0}),u(I)!=="svelte-5l7ldd"&&(I.textContent=ke),ie.forEach(t),Y=l(e),C=n(e,"P",{"data-svelte-h":!0}),u(C)!=="svelte-is33n6"&&(C.innerHTML=$e),B=l(e),y=n(e,"UL",{"data-svelte-h":!0}),u(y)!=="svelte-12qbi16"&&(y.innerHTML=Pe),G=l(e),k=n(e,"P",{"data-svelte-h":!0}),u(k)!=="svelte-tuxeb9"&&(k.textContent=qe),K=l(e),$=n(e,"P",{"data-svelte-h":!0}),u($)!=="svelte-19jmf8q"&&($.textContent=Te),Q=l(e),f=n(e,"H2",{class:!0});var he=c(f);b=n(he,"A",{id:!0,class:!0,href:!0});var ze=c(b);z=n(ze,"SPAN",{});var Oe=c(z);de(P.$$.fragment,Oe),Oe.forEach(t),ze.forEach(t),ge=l(he),W=n(he,"SPAN",{"data-svelte-h":!0}),u(W)!=="svelte-1p6i913"&&(W.textContent=je),he.forEach(t),V=l(e),q=n(e,"P",{"data-svelte-h":!0}),u(q)!=="svelte-1r0ezeb"&&(q.textContent=Ae),X=l(e),T=n(e,"P",{"data-svelte-h":!0}),u(T)!=="svelte-wyypiy"&&(T.textContent=He),Z=l(e),j=n(e,"UL",{"data-svelte-h":!0}),u(j)!=="svelte-n6lfh"&&(j.innerHTML=Se),ee=l(e),A=n(e,"P",{"data-svelte-h":!0}),u(A)!=="svelte-1e44dmt"&&(A.innerHTML=Le),te=l(e),v=n(e,"H2",{class:!0});var ue=c(v);x=n(ue,"A",{id:!0,class:!0,href:!0});var Fe=c(x);O=n(Fe,"SPAN",{});var Re=c(O);de(H.$$.fragment,Re),Re.forEach(t),Fe.forEach(t),_e=l(ue),D=n(ue,"SPAN",{"data-svelte-h":!0}),u(D)!=="svelte-s915b0"&&(D.textContent=Me),ue.forEach(t),re=l(e),S=n(e,"P",{"data-svelte-h":!0}),u(S)!=="svelte-7k57hi"&&(S.textContent=Ee),se=l(e),L=n(e,"P",{"data-svelte-h":!0}),u(L)!=="svelte-1jj7ypx"&&(L.innerHTML=Ne),ae=l(e),m=n(e,"H2",{class:!0});var ce=c(m);g=n(ce,"A",{id:!0,class:!0,href:!0});var Ye=c(g);F=n(Ye,"SPAN",{});var Be=c(F);de(M.$$.fragment,Be),Be.forEach(t),Ye.forEach(t),Ce=l(ce),J=n(ce,"SPAN",{"data-svelte-h":!0}),u(J)!=="svelte-14p6x6h"&&(J.textContent=Ie),ce.forEach(t),ne=l(e),E=n(e,"P",{"data-svelte-h":!0}),u(E)!=="svelte-vx3101"&&(E.innerHTML=We),oe=l(e),N=n(e,"P",{"data-svelte-h":!0}),u(N)!=="svelte-l44lf6"&&(N.textContent=De),this.h()},h(){i(p,"name","hf:doc:metadata"),i(p,"content",JSON.stringify(tt)),i(w,"id","server-infrastructure"),i(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(w,"href","#server-infrastructure"),i(d,"class","relative group"),i(b,"id","job-queue"),i(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(b,"href","#job-queue"),i(f,"class","relative group"),i(x,"id","workers"),i(x,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(x,"href","#workers"),i(v,"class","relative group"),i(g,"id","cache"),i(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(g,"href","#cache"),i(m,"class","relative group")},m(e,r){h(document.head,p),s(e,R,r),s(e,d,r),h(d,w),h(w,U),fe(_,U,null),h(d,xe),h(d,I),s(e,Y,r),s(e,C,r),s(e,B,r),s(e,y,r),s(e,G,r),s(e,k,r),s(e,K,r),s(e,$,r),s(e,Q,r),s(e,f,r),h(f,b),h(b,z),fe(P,z,null),h(f,ge),h(f,W),s(e,V,r),s(e,q,r),s(e,X,r),s(e,T,r),s(e,Z,r),s(e,j,r),s(e,ee,r),s(e,A,r),s(e,te,r),s(e,v,r),h(v,x),h(x,O),fe(H,O,null),h(v,_e),h(v,D),s(e,re,r),s(e,S,r),s(e,se,r),s(e,L,r),s(e,ae,r),s(e,m,r),h(m,g),h(g,F),fe(M,F,null),h(m,Ce),h(m,J),s(e,ne,r),s(e,E,r),s(e,oe,r),s(e,N,r),le=!0},p:Ke,i(e){le||(ve(_.$$.fragment,e),ve(P.$$.fragment,e),ve(H.$$.fragment,e),ve(M.$$.fragment,e),le=!0)},o(e){me(_.$$.fragment,e),me(P.$$.fragment,e),me(H.$$.fragment,e),me(M.$$.fragment,e),le=!1},d(e){e&&(t(R),t(d),t(Y),t(C),t(B),t(y),t(G),t(k),t(K),t($),t(Q),t(f),t(V),t(q),t(X),t(T),t(Z),t(j),t(ee),t(A),t(te),t(v),t(re),t(S),t(se),t(L),t(ae),t(m),t(ne),t(E),t(oe),t(N)),t(p),we(_),we(P),we(H),we(M)}}}const tt={local:"server-infrastructure",sections:[{local:"job-queue",title:"Job queue"},{local:"workers",title:"Workers"},{local:"cache",title:"Cache"}],title:"Server infrastructure"};function rt(ye){return Qe(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ot extends Ve{constructor(p){super(),Xe(this,p,rt,et,Ge,{})}}export{ot as component};
